#include "StdAfx.h"
#include "DropTarget.h"
#include "Defs.h"

extern UINT g_cRefT		= 0;
extern UINT g_cWndCountT = 0;

HRESULT STDMETHODCALLTYPE 
IDropTargetShare::QueryInterface(REFIID riid, LPVOID FAR *ppvObject)
{
	HRESULT hr = S_OK;

	*ppvObject = 0;
	if(IsEqualIID(riid, IID_IDropTarget) || IsEqualIID(riid, IID_IUnknown))
		*ppvObject = this;

	if(*ppvObject != 0)
	{
		((LPUNKNOWN)*ppvObject)->AddRef();
		hr = NOERROR;
	}
	else
		hr = E_NOINTERFACE;
	return hr;
}

ULONG STDMETHODCALLTYPE 
IDropTargetShare::AddRef()
{
	g_cRefT++;
	return g_cRefT;
}

ULONG STDMETHODCALLTYPE 
IDropTargetShare::Release()
{
	g_cRefT--;
	return g_cRefT;
}

HRESULT STDMETHODCALLTYPE 
IDropTargetShare::DragEnter(IDataObject __RPC_FAR *pDataObj, DWORD grfKeyState, POINTL pt, DWORD __RPC_FAR *pdwEffect)
{
	_UNREFERENCED_PARAMETER_(pDataObj);
	_UNREFERENCED_PARAMETER_(grfKeyState);
	_UNREFERENCED_PARAMETER_(pt);
	_UNREFERENCED_PARAMETER_(pdwEffect);

	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IDropTargetShare::DragOver(DWORD grfKeyState, POINTL pt, DWORD __RPC_FAR *pdwEffect)
{
	_UNREFERENCED_PARAMETER_(grfKeyState);
	_UNREFERENCED_PARAMETER_(pt);
	_UNREFERENCED_PARAMETER_(pdwEffect);

	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IDropTargetShare::DragLeave()
{
	return S_OK;
}

HRESULT STDMETHODCALLTYPE 
IDropTargetShare::Drop(IDataObject __RPC_FAR *pDataObj, DWORD grfKeyState, POINTL pt, DWORD __RPC_FAR *pdwEffect)
{
	LPENUMFORMATETC pefEtc = 0;
	
	STGMEDIUM		stgM;
	FORMATETC		fEtc;

	ULONG			ulFetched	= 0L;
	UINT			nFileCount  = 0;

	HRESULT			hr = S_OK;

	_UNREFERENCED_PARAMETER_(grfKeyState);
	_UNREFERENCED_PARAMETER_(pdwEffect);

	hr = pDataObj->EnumFormatEtc(DATADIR_GET, &pefEtc);
	if(SUCCEEDED(hr))
	{
		hr = pefEtc->Reset();
		if(SUCCEEDED(hr))
		{
			//	disable 'conditional expression is not constant'
			#ifdef _MSC_VER
			#pragma warning(disable:4127)	
			#endif
			while(TRUE)
			#ifdef _MSC_VER
			#pragma warning(default:4127)	
			#endif
			{
				hr = pefEtc->Next(1, &fEtc, &ulFetched);
				if(FAILED(hr) || (ulFetched <= 0))
					break;

				fEtc.cfFormat	= CF_HDROP;
				fEtc.dwAspect	= DVASPECT_CONTENT;
				fEtc.lindex		= -1;
				fEtc.ptd		= NULL;
				fEtc.tymed		= TYMED_HGLOBAL;

				hr = pDataObj->GetData(&fEtc, &stgM);
				if(SUCCEEDED(hr))
				{
					if(stgM.tymed == TYMED_HGLOBAL)
					{
						nFileCount = DragQueryFile((HDROP)stgM.hGlobal, (UINT)INVALID_HANDLE_VALUE, NULL, 0);
						if(nFileCount >= 1)
						{
							HWND hwndTV		  = 0;
							HWND hwndDlg = 0;
							POINT _pt;
							
							_pt.x = pt.x;
							_pt.y = pt.y;

							//	this should be the tree control (the 'dragee') --> dialog 
							hwndTV	= WindowFromPoint(_pt);
							hwndDlg = GetParent(hwndTV);	//	tree --> dialog

							if(IsWindow(hwndDlg))
							{
								SendMessage(hwndDlg, WM_DROPFILES, (WPARAM)stgM.hGlobal, (LPARAM)0);
								break;
							}
						}
					}
				}
			}
		}
	}

	if(pefEtc)
		pefEtc->Release();

	return hr;
}

